#include "Complex.h"
#include <math.h>

Complex::Complex()
{
	this->real = 0;
	this->imag = 0;
}

Complex::Complex(double r, double i)
{
	this->real = r;
	this->imag = i;
}

Complex::Complex(Complex& c)
{
	this->real = c.getReal();
	this->imag = c.getImag();
}

Complex::Complex(Py_complex* c)
{
	if(c->real == 0)
		this->real = 0;
	else
		this->real = c->real;
	if(c->imag == 0)
		this->imag = 0;
	else
		this->imag = c->imag;
}

Complex Complex::operator+(Complex& rhs)
{
	return Complex(this->real+rhs.getReal(),this->imag+rhs.getImag());
}

Complex Complex::operator*(Complex& rhs)
{
	double realSquare = this->real * rhs.getReal();
	double middle = this->real*rhs.getImag()+this->imag*rhs.getReal();
	double imagSquare = this->imag * rhs.getImag();
	return Complex(realSquare,middle+imagSquare);
}

Py_complex* Complex::toOld(void)
{
	Py_complex* c;
	c->real = this->real;
	c->imag = this->imag;
	return c;
}

double Complex::getMag()
{
	return sqrt(pow(this->real,2)+pow(this->imag,2));
}
