#include "Julia_Set.h"

extern "C" static PyObject* escapeMap(PyObject* self, PyObject* args)
{
	Py_complex* _seed;
	Complex seed;
	int iters;
	int windowSize[2];
	double rangeX[2] = {-2,2};
	double rangeY[2] = {-2,2};

	if(!PyArg_ParseTuple(args,"Di(ii)|(dd)(dd)",_seed,&iters,&windowSize[0],&windowSize[1],&rangeX[0],&rangeX[1],&rangeY[0],&rangeY[1])) return NULL;
	seed = Complex(_seed);
	Julia_Set* j = new Julia_Set(windowSize,rangeX,rangeY,seed,iters);
	return j->calculate();
}

extern "C" static PyObject* classRep(PyObject* self, PyObject* args)
{
	Py_complex* c;
	Complex* cplx;
	if(!PyArg_ParseTuple(args,"D",c)) return NULL;
	cplx = new Complex(c);
	return Py_BuildValue("D",cplx->toOld());
}

static PyMethodDef ctest_funcs[] = {
	{"classRep",(PyCFunction)classRep,METH_VARARGS," "},
	{"escapeMap",(PyCFunction)escapeMap,METH_VARARGS," "},
	{NULL}
};

extern "C" void initctest(void)
{
	Py_InitModule3("ctest",ctest_funcs," ");
}
